package VistaControlador;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JCheckBox;
import javax.swing.JOptionPane;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import Logica.Gestion;

public class ControladorAniadirVisualizar implements ActionListener,ChangeListener{

	private VistaAniadirVisualizar vista;
	public ControladorAniadirVisualizar(VistaAniadirVisualizar vista) {
		this.vista=vista;
		this.aniadirListeners();
	}

	public void actionPerformed(ActionEvent e) {
		if(e.getActionCommand().equals(this.vista.boton.getActionCommand())) {
			String nombre=JOptionPane.showInputDialog("Introduce un nuevo gasto o ingreso");
			if(nombre==null) return;
			if(nombre.equals("")) {
				JOptionPane.showMessageDialog(null, "Debe introducir algo", "error", JOptionPane.WARNING_MESSAGE);
				return;
			}
			String dinero=JOptionPane.showInputDialog("Introduce a cuanto asciende");
			if(dinero==null) return;
			if(dinero.equals("")) {
				JOptionPane.showMessageDialog(null, "Debe introducir algo", "error", JOptionPane.WARNING_MESSAGE);
				return;
			}
			
			try {
				this.vista.aniadirElemento(nombre, Float.parseFloat(dinero),this);
				this.vista.menu.panel.actualizarDatos(this.vista.gestiones);
				this.vista.menu.panel.revalidate();
				this.vista.menu.panel.repaint();
			}catch (NumberFormatException ex) {
				JOptionPane.showMessageDialog(null, "Debe introducir un numero", "error", JOptionPane.WARNING_MESSAGE);
			}
		}else {
			JCheckBox pulsado=(JCheckBox)e.getSource();
			for(int i=0;i<vista.gestiones.getElementos().size();i++) {
				if(vista.gestiones.getElementos().get(i).toString().equals(pulsado.getText())) {
					vista.gestiones.alterarVisibilidad(i);
					this.vista.menu.panel.actualizarDatos(this.vista.gestiones);
					this.vista.menu.panel.revalidate();
					this.vista.menu.panel.repaint();
				}
			}
		}
	}
	
	private void aniadirListeners() {
		vista.boton.addActionListener(this);
		vista.boton.setActionCommand("Aniadir");
		int contador=0;
		for(JCheckBox check:this.vista.transacciones) {
			check.addActionListener(this);
			check.setActionCommand("pulsar "+contador);
			contador++;
		}
	}

	@Override
	public void stateChanged(ChangeEvent e) {
		// TODO Auto-generated method stub
		
	}
	
}
